#include <mega32.h>
#include <delay.h>
// I2C Bus functions
#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>
#include <stdio.h>
// Declare your global variables here
#define EEPROM_BUS_ADDRESS 0xA0
 unsigned char read;
/***************************************************************************************
+    2402.
+      .
+     .
****************************************************************************************/
unsigned char eep_read(unsigned char address1, unsigned char address2) {
unsigned char data;                    //   
i2c_start();                           //  ""   i2c
i2c_write(EEPROM_BUS_ADDRESS);         //    
i2c_write(address1);
i2c_write(address2);                    //     
i2c_start();                           //  ""  
i2c_write(EEPROM_BUS_ADDRESS | 1);     //      
data=i2c_read(0);                      //       
i2c_stop();                            //  ""
return data;                           //  
}

/***************************************************************************************
+     2402.
+       (adress).
+          .
****************************************************************************************/
void eep_write(unsigned char address1, unsigned char address2, unsigned char data) {   
i2c_start();                           //  ""   i2c
i2c_write(EEPROM_BUS_ADDRESS);         //    
i2c_write(address1);
i2c_write(address2);                    //     
i2c_write(data);                       //   
i2c_stop(); 
delay_ms(10);                           //  ""
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0b00010000;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// I2C Bus initialization
i2c_init();
eep_write(0x00,0x01,0x8F);  
                        
                       
while (1)
      {
      // Place your code here
       delay_ms(300);
       read=eep_read(0x00,0x01);
       printf("%u",read);
          if(eep_read(0x00,0x01)==0x8F){     
              
               PORTB.4=1;               
               //delay_ms(1000);          
          };
      };
}